"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _boom = _interopRequireDefault(require("boom"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (permission, options = {
  getSubject: req => req.user || {},
  getObject: () => {}
}) => async (req, res, next) => {
  const subject = options.getSubject(req);
  const object = options.getObject(req);
  const {
    permissionsManager
  } = req.app.modules.get('oors.security');

  try {
    const isAllowed = await permissionsManager.can({
      subject,
      permission,
      object
    });

    if (!isAllowed) {
      throw _boom.default.unauthorized(`Missing "${permission}" permission!`);
    }

    next();
  } catch (err) {
    next(err);
  }
};

exports.default = _default;